//
//  MechanicsView.swift
//  SwiftVector
//
//  Created by Crazy凡 on 16/9/9.
//  Copyright © 2016年 Crazy凡. All rights reserved.
//

import UIKit

let number:Int = 15

class MechanicsView: UIView {
    let pointManager = PointManager.shareManager;
    var touchPoint:Point?
    var lastPoint:CGPoint?
    
    override init(frame: CGRect) {
        super.init(frame: frame)
        self.backgroundColor = UIColor.blackColor()
        pointManager.addPoints(number)
        pointManager.addPointToView(self)
    }
    
    required init?(coder aDecoder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }
    
    override func touchesBegan(touches: Set<UITouch>, withEvent event: UIEvent?) {
//        pointManager.pauseMove()
        lastPoint = getPoint(touches)
        touchPoint = pointManager.getCurrentPositionPoint(lastPoint!)
    }
    
    override func touchesMoved(touches: Set<UITouch>, withEvent event: UIEvent?) {
        dealTouchEvent(touches)
    }
    
    override func touchesEnded(touches: Set<UITouch>, withEvent event: UIEvent?) {
        dealTouchEvent(touches)
        touchPoint = nil
//        pointManager.startMove()
    }
    
    func dealTouchEvent(touches: Set<UITouch>) {
        let currentRouchPoint:CGPoint = getPoint(touches)
        if touchPoint != nil {
            pointManager.movePointToNewPosition(touchPoint!, position:currentRouchPoint)
        } else {
            pointManager.moveAllWithVector(Vector.vectorFromePointToPoint(lastPoint!, pointb:currentRouchPoint))
            lastPoint = currentRouchPoint
        }
    }
    
    private func getPoint(touches: Set<UITouch>) -> CGPoint{
        return (touches.first?.locationInView(self))!
    }
    
    func startMove(){
        pointManager.startMove()
    }
    
    func pauseMove(){
        pointManager.pauseMove()
    }
}
