//
//  Point.swift
//  SwiftVector
//
//  Created by Crazy凡 on 16/9/8.
//  Copyright © 2016年 Crazy凡. All rights reserved.
//

import UIKit

let minColorValue:Float = 0.2

class Point: UIView {
    var s:Vector
    var v:Vector
    var a:Vector
    var f:Vector
    
    override init(frame: CGRect) {
        
        s = Vector.vector()
        v = Vector.vector()
        a = Vector.vector()
        f = Vector.vector()
        
        super.init(frame: frame)
        
        self.frame = CGRectMake(0, 0, 15, 15);
        self.backgroundColor = UIColor.init(colorLiteralRed:randomC(), green: randomC(), blue: randomC(), alpha: 1)
        self.layer.masksToBounds = true
        self.layer.cornerRadius = 7.5
    }
    
    required init?(coder aDecoder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }
    
    func randomC() -> Float {
        let number = Float(Double(arc4random() % 1000) / 1000.0)
        return number < minColorValue ? minColorValue : number
    }
    
    func setPosition(){
        self.center = s.toPoint()
    }
    
    func moveToPosition(position:CGPoint) {
        self.s = Vector.vectorWithPoint(position)
        setPosition()
    }
    
    func moveWithVector(vector:Vector) {
        self.s.add(vector)
        setPosition()
    }
    
    class func point() -> Point {
        return Point.init(frame: CGRectZero)
    }
}
