//
//  Vector.swift
//  SwiftVector
//
//  Created by Crazy凡 on 16/9/8.
//  Copyright © 2016年 Crazy凡. All rights reserved.
//

import UIKit

class Vector: NSObject {
    var x:CGFloat
    var y:CGFloat
    
    init(x:CGFloat, y:CGFloat) {
        self.x = x
        self.y = y
    }
    
    func square() -> CGFloat {
        return x * x + y * y;
    }
    
    func length() -> CGFloat {
        return sqrt(self.square());
    }
    
    func add(vector:Vector) -> Vector {
        x += vector.x
        y += vector.y
        return self
    }
    
    func minus(vector:Vector) -> Vector {
        x -= vector.x
        y -= vector.y
        return self
    }
    
    func multipy(multiple:CGFloat) -> Vector {
        x *= multiple
        y *= multiple
        return self
    }
    
    func normalize(length:CGFloat) -> Vector {
        let proportion = (length == 0 ? 1 : length / self.length());
        x *= proportion
        y *= proportion
        return self
    }
    
    func toPoint() -> CGPoint {
        return CGPointMake(x, y)
    }
    
    class func randomNum(value:CGFloat) -> CGFloat {
        return CGFloat(arc4random()) % 1000 / 1000.0 * value;
    }
    
    class func randomVector(size:CGSize) -> Vector {
        return Vector.init(x: Vector.randomNum(size.width), y: Vector.randomNum(size.height))
    }
    
    
    
    class func vectorFromVectorAToVectorB(vectorA:Vector, vectorB:Vector) -> Vector{
        return Vector.init(x: vectorB.x - vectorA.x, y: vectorB.y - vectorA.y)
    }
    
    class func vector() -> Vector {
        return Vector.init(x: 0, y: 0)
    }
    
    class func vectorWithVector(vector:Vector) -> Vector {
        return Vector.init(x: vector.x, y: vector.y)
    }
    
    class func vectorWithPoint(point:CGPoint) -> Vector {
        return Vector.init(x: point.x, y: point.y)
    }
    
    class func vectorFromePointToPoint(pointa:CGPoint, pointb:CGPoint) -> Vector{
        return Vector.init(x: pointb.x - pointa.x, y: pointb.y - pointa.y)
    }
    
}
